module td_led ();
`timescale 1ns/1ns  // 睡眠的 单位/精度

reg td_key;  // 定义内内部的信号 设置为寄存器类型(按键是在 initial 语句中赋值, 以使用寄存器类型)
wire td_led;  // 定义内部的输出信号, 使用 wire 类型

// 信号初始化的设置
initial begin
    td_key <= 1'b1;  // 不阻塞的设置内部初始值

    #200;  // 阻塞 200ns
    td_key <= 1'b0;

    #500;
    td_key <= 1'b1;

    #1000;
    td_key <= 1'b0;
end

// 例化, 并传入一些参数
led u_led(
    .key (td_key),
    .led (td_led)  // 输出需要是 wire类型, 虽然led模块内部, 他是reg类型, 不过对于外部而言, 他不是alaways中涉及的信号, 所以需要使用 wire类型

    // .xx ()  // 如果还有其他的管脚, 空白表示 不连了, 悬空
);
endmodule